Attribute VB_Name = "Module_Main"
Option Explicit

Dim WMI, oQ

Const s_db_table As String = "stats"
Const i_tmrDBshow_interval As Integer = 3000 'msec

Dim s_db_file As String
Dim s_Word_file As String
Dim s_Krnl_file As String

Dim b_RunStat As Boolean
Dim i_Current_Rows As Long
Dim i_Current_PID As Long

Sub fun_mnuGoStop()
Dim o
b_RunStat = Not b_RunStat
If b_RunStat Then
 If Len(Dir$(s_db_file)) = 0 Then
  funDBCreateDB (s_db_file)
  Call funDBCreateTable(s_db_file, s_db_table)
 End If
 f1.mnuGo.Caption = " "
 i_Current_PID = Shell(s_Krnl_file & " -run", vbHide)
Else
 f1.mnuGo.Caption = " "
 Set oQ = WMI.ExecQuery("select * from Win32_Process where ProcessID = " & i_Current_PID)
 For Each o In oQ
  o.Terminate
 Next
End If
End Sub

Sub funLoad()
funWMIinit
funGridInit
b_RunStat = False
f1.tmrDBshow.Interval = i_tmrDBshow_interval

s_db_file = App.Path
If Right$(s_db_file, 1) <> "\" Then s_db_file = s_db_file & "\"
s_Krnl_file = s_db_file & "krnl.exe"
s_Word_file = s_db_file & "out.doc"
s_db_file = s_db_file & "db.mdb"

End Sub

Sub funGridInit()
With f1.g
 .Rows = 32000
 .Cols = 3
 .Font.Name = "Courier"
 .Font.Size = 9
 .ColWidth(0) = 650
 .ColWidth(1) = 2000
 .ColWidth(2) = 2000
 .TextMatrix(0, 0) = "No"
 .TextMatrix(0, 1) = ""
 .TextMatrix(0, 2) = ""
 .Visible = True
End With
End Sub

Sub funWMIinit()
On Error GoTo ErrH
Set WMI = GetObject("winmgmts:")
Exit Sub
ErrH:
MsgBox "       WMI." & vbCrLf & "  .", vbCritical, "  WMI"
funEnd
End Sub

Sub funEnd()
Dim o
Set oQ = WMI.ExecQuery("select * from Win32_Process where ProcessID = " & i_Current_PID)
For Each o In oQ
 o.Terminate
Next
Set WMI = Nothing: Set oQ = Nothing
End
End Sub

Sub funDBclear()
On Error GoTo ErrH
If Len(Dir$(s_db_file, vbHidden)) <> 0 Then
 Kill s_db_file
End If

funDBCreateDB (s_db_file)
Call funDBCreateTable(s_db_file, s_db_table)

Dim i_buf As Long
Dim j_buf As Long
With f1.g
 .Redraw = False
 For i_buf = .FixedRows To .Rows - 1
  For j_buf = .FixedCols To .Cols - 1
   .TextMatrix(i_buf, j_buf) = ""
  Next j_buf
 Next i_buf
 .Redraw = True
End With

MsgBox "  !"
Exit Sub
ErrH:
MsgBox "   .", vbCritical
End Sub

Sub funDBshow()
If Len(Dir$(s_db_file, vbHidden)) = 0 Then
 MsgBox "    ."
 f1.tmrDBshow.Enabled = False
 f1.mnuRefresh.Checked = False
 Exit Sub
End If

Dim dbW As Workspace
Dim dbDB As Database
Dim dbT As Recordset

On Error Resume Next
Set dbW = DBEngine.Workspaces(0)
Set dbDB = dbW.OpenDatabase(s_db_file)
Set dbT = dbDB.OpenRecordset(s_db_table, dbOpenSnapshot)
If dbT.EOF And dbT.BOF Then
 If Err Then 'noth.
 Else
  MsgBox "  ."
 End If
 f1.tmrDBshow.Enabled = False
 f1.mnuRefresh.Checked = False
 Exit Sub
 dbT.Close
 dbDB.Close
End If

Dim s1 As String
Dim s2 As String
Dim s3 As String
Dim i As Long
Dim j As Long
f1.g.Redraw = False
dbT.MoveFirst
j = 1
Do While Not dbT.EOF
 s1 = dbT!Field1
 s2 = dbT!Field2
 f1.g.TextMatrix(j, 0) = j
 f1.g.TextMatrix(j, 1) = s1
 f1.g.TextMatrix(j, 2) = s2
 dbT.MoveNext
 j = j + 1
Loop
i_Current_Rows = j
f1.g.Redraw = True
dbT.Close
dbDB.Close
End Sub

Sub funSave2File()
funDBshow
On Error GoTo ErrH:

If Len(Dir$(s_Word_file, vbHidden)) <> 0 Then Kill s_Word_file

Dim WordApp As Word.Application
Dim DocWord As Word.Document

Set WordApp = New Word.Application
WordApp.Visible = True

Set DocWord = WordApp.Documents.Add
DocWord.Activate
DocWord.SaveAs s_Word_file

Dim TableWord As Word.Table
Set TableWord = DocWord.Tables.Add(DocWord.Range(), i_Current_Rows + 1, 3)
Dim i As Long
Dim j As Long
For i = 0 To i_Current_Rows
 For j = 0 To 2
  TableWord.Cell(i + 1, j + 1).Range.Text = f1.g.TextMatrix(i, j)
 Next j
Next i

DocWord.Save
'DocWord.Close True
'WordApp.Quit True
Set DocWord = Nothing: Set WordApp = Nothing
Exit Sub
ErrH:
MsgBox "  Word-!"
End Sub

Sub fun_tmrDBshow()
funDBshow
End Sub

Sub fun_mnuRefresh()
funDBshow
Dim b As Boolean
b = f1.mnuRefresh.Checked
If b Then
 f1.tmrDBshow.Enabled = False
Else
 f1.tmrDBshow.Enabled = True
End If
f1.mnuRefresh.Checked = Not b
End Sub


